/**
 * Created by janis dähne.
 */
import {
  SET_idAction, SET_displayNameAction,
  SET_emailAction, SET_canCreateGroupsAction, SET_canDeleteGroupsAction,
  SET_canCreateRolesAction, SET_canChangeRolesAction, SET_canDeleteRolesAction, SET_canManageNewUsersAction,
  SET_canChangeOtherUsersSystemRoleAction, SET_canDeleteActivatedUsersAction, SET_canChangeUserDataAction,
  SET_canChangeSystemSettingsAction, SET_canManageTagsAction, SET_canViewDashboardAction
} from "../../../reducers/systemRolesSite/dialog/systemRoleReducer";
import {ActionType} from "../../../reducers/systemRolesSite/dialog/changeSystemRoleDIalogActionTypes";
import {SystemRoleFullBase} from "../../../../types/userData";
import {ThunkAction} from "redux-thunk";
import {MultiActions} from "../../types";


export function setTargetSystemRole(systemRole: SystemRoleFullBase): MultiActions {
  return (dispatch) => {
    dispatch(setId(systemRole.id))
    dispatch(setDisplayName(systemRole.displayName))
    dispatch(setEmail(systemRole.email))

    dispatch(setCanCreateGroups(systemRole.canCreateGroups))
    dispatch(setCanDeleteGroups(systemRole.canDeleteGroups))

    dispatch(setCanCreateRoles(systemRole.canCreateRoles))
    dispatch(setCanChangeRoles(systemRole.canChangeRoles))
    dispatch(setCanDeleteRoles(systemRole.canDeleteRoles))

    dispatch(setCanManageNewUsers(systemRole.canManageNewUsers))
    dispatch(setCanChangeOtherUsersSystemRole(systemRole.canChangeOtherUsersSystemRole))
    dispatch(setCanDeleteActivatedUsers(systemRole.canDeleteActivatedUsers))
    dispatch(setCanChangeUserData(systemRole.canChangeUserData))
    dispatch(setCanChangeSystemSettings(systemRole.canChangeSystemSettings))
    dispatch(setCanManageTags(systemRole.canManageTags))
    dispatch(setCanViewDashboard(systemRole.canViewDashboard))
  }
}

export function setId(id: number): SET_idAction {
  return {
    type: ActionType.SET_id,
    id
  }
}

export function setDisplayName(displayName: string): SET_displayNameAction {
  return {
    type: ActionType.SET_displayName,
    displayName
  }
}

export function setEmail(email: string): SET_emailAction {
  return {
    type: ActionType.SET_email,
    email
  }
}

export function setCanCreateGroups(can: boolean): SET_canCreateGroupsAction {
  return {
    type: ActionType.SET_canCreateGroups,
    can
  }
}


export function setCanDeleteGroups(can: boolean): SET_canDeleteGroupsAction {
  return {
    type: ActionType.SET_canDeleteGroups,
    can
  }
}

export function setCanCreateRoles(can: boolean): SET_canCreateRolesAction {
  return {
    type: ActionType.SET_canCreateRoles,
    can
  }
}

export function setCanChangeRoles(can: boolean): SET_canChangeRolesAction {
  return {
    type: ActionType.SET_canChangeRoles,
    can
  }
}

export function setCanDeleteRoles(can: boolean): SET_canDeleteRolesAction {
  return {
    type: ActionType.SET_canDeleteRoles,
    can
  }
}

export function setCanManageNewUsers(can: boolean): SET_canManageNewUsersAction {
  return {
    type: ActionType.SET_canManageNewUsers,
    can
  }
}

export function setCanChangeOtherUsersSystemRole(can: boolean): SET_canChangeOtherUsersSystemRoleAction {
  return {
    type: ActionType.SET_canChangeOtherUsersSystemRole,
    can
  }
}

export function setCanDeleteActivatedUsers(can: boolean): SET_canDeleteActivatedUsersAction {
  return {
    type: ActionType.SET_canDeleteActivatedUsers,
    can
  }
}

export function setCanChangeUserData(can: boolean): SET_canChangeUserDataAction {
  return {
    type: ActionType.SET_canChangeUserData,
    can
  }
}

export function setCanChangeSystemSettings(can: boolean): SET_canChangeSystemSettingsAction {
  return {
    type: ActionType.SET_canChangeSystemSettings,
    can
  }
}

export function setCanManageTags(can: boolean): SET_canManageTagsAction {
  return {
    type: ActionType.SET_canManageTags,
    can
  }
}

export function setCanViewDashboard(can: boolean): SET_canViewDashboardAction {
  return {
    type: ActionType.SET_canViewDashboard,
    can
  }
}